Index: src/roadveh_cmd.cpp
===================================================================
--- src/roadveh_cmd.cpp	(revision 13552)
+++ src/roadveh_cmd.cpp	(working copy)
@@ -43,6 +43,7 @@
 #include "depot_base.h"
 #include "depot_func.h"
 #include "effectvehicle_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 
@@ -187,7 +188,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsRoadDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_player)) return CMD_ERROR;
+	if (!IsTileOwner(tile, _current_player) && !SharedRoadDepots(tile, _current_player)) return CMD_ERROR;
 
 	if (HasTileRoadType(tile, ROADTYPE_TRAM) != HasBit(EngInfo(p1)->misc_flags, EF_ROAD_TRAM)) return_cmd_error(STR_DEPOT_WRONG_DEPOT_TYPE);
 
@@ -288,6 +289,7 @@
 		GetPlayer(_current_player)->num_engines[p1]++;
 	}
 
+	SharedDepotProvision(cost, GetTileOwner(tile), flags);
 	return cost;
 }
 
@@ -823,6 +825,7 @@
 
 static void RoadVehArrivesAt(const Vehicle* v, Station* st)
 {
+	if (st->owner != v->owner) SharedStationFee(st->owner, v->index);
 	if (IsCargoInClass(v->cargo_type, CC_PASSENGERS)) {
 		/* Check if station was ever visited before */
 		if (!(st->had_vehicle_of_type & HVOT_BUS)) {
@@ -834,7 +837,7 @@
 				v->index,
 				0);
 		}
-	} else {
+	} else {		
 		/* Check if station was ever visited before */
 		if (!(st->had_vehicle_of_type & HVOT_TRUCK)) {
 			st->had_vehicle_of_type |= HVOT_TRUCK;
@@ -1066,14 +1069,14 @@
 	TrackdirBits trackdirs = TrackStatusToTrackdirBits(ts);
 
 	if (IsTileType(tile, MP_ROAD)) {
-		if (IsRoadDepot(tile) && (!IsTileOwner(tile, v->owner) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
+		if (IsRoadDepot(tile) && ((!IsTileOwner(tile, v->owner) && !SharedRoadDepots(tile,v->owner)) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
 			/* Road depot owned by another player or with the wrong orientation */
 			trackdirs = TRACKDIR_BIT_NONE;
 		}
 	} else if (IsTileType(tile, MP_STATION) && IsStandardRoadStopTile(tile)) {
 		/* Standard road stop (drive-through stops are treated as normal road) */
 
-		if (!IsTileOwner(tile, v->owner) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
+		if (((!IsTileOwner(tile, v->owner))&& !SharedRoadStops(tile,v->owner)) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
 			/* different station owner or wrong orientation or the vehicle has articulated parts */
 			trackdirs = TRACKDIR_BIT_NONE;
 		} else {
Index: src/economy_type.h
===================================================================
--- src/economy_type.h	(revision 13552)
+++ src/economy_type.h	(working copy)
@@ -118,10 +118,12 @@
 	EXPENSES_AIRCRAFT_RUN,
 	EXPENSES_SHIP_RUN,
 	EXPENSES_PROPERTY,
+	EXPENSES_SHARED_INF_RUN,
 	EXPENSES_TRAIN_INC,
 	EXPENSES_ROADVEH_INC,
 	EXPENSES_AIRCRAFT_INC,
 	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INF_INC,
 	EXPENSES_LOAN_INT,
 	EXPENSES_OTHER,
 	EXPENSES_END,
Index: src/sharedinfrastructure.h
===================================================================
--- src/sharedinfrastructure.h	(revision 0)
+++ src/sharedinfrastructure.h	(revision 0)
@@ -0,0 +1,71 @@
+/* $Id: sharedinfrastructure.h $ */
+
+/** @file sharedinfrastructure.h Various declarations for shared infrastructures */
+
+#ifndef SHAREDINFRASTRUCTURE_H
+#define SHAREDINFRASTRUCTURE_H
+
+#include "openttd.h"
+#include "tile_type.h"
+#include "vehicle_type.h"
+
+/* bitmask of shared infrastructure */
+enum {
+	SHARED_NONE             =  0,             ///< No sharing
+	SHARED_RAILWAY_TRACKS   = (1 << 0),       ///< Railway tracks sharing 
+	SHARED_RAILWAY_STATIONS = (1 << 1),       ///< Railway station sharing
+	SHARED_RAILWAY_DEPOTS   = (1 << 2),       ///< Railway depots sharing
+	SHARED_AIRPORTS         = (1 << 3),       ///< Airports sharing
+	SHARED_ROAD_DEPOTS      = (1 << 4),       ///< Road depots sharing
+	SHARED_ROAD_STOPS       = (1 << 5),       ///< Road stops sharing
+	SHARED_WATER_DEPOTS     = (1 << 6),       ///< Water depots sharing
+	SHARED_HARBOURS         = (1 << 7),       ///< Road depots sharing
+	SHARED_ALL              = SHARED_RAILWAY_TRACKS | SHARED_RAILWAY_STATIONS | SHARED_RAILWAY_DEPOTS | SHARED_AIRPORTS
+					| SHARED_ROAD_DEPOTS | SHARED_ROAD_STOPS | SHARED_WATER_DEPOTS | SHARED_HARBOURS, ///< All sharing
+};
+
+/* variables for player's shared infrastructure GUI */
+extern bool _si_railway_tracks;               ///< allow railway tracks sharing
+extern bool _si_railway_stations;             ///< allow railway stations sharing
+extern bool _si_railway_depots;               ///< allow railway depots sharing
+extern bool _si_airports;                     ///< allow airports sharing
+extern bool _si_road_depots;                  ///< allow road depots sharing
+extern bool _si_road_stops;                   ///< allow road stops sharing
+extern bool _si_water_depots;                 ///< allow water depots sharing
+extern bool _si_harbours;                     ///< allow harbours sharing
+extern uint16 _si_tontile_cost;               ///< cost for tracks sharing payment (per 1000 tons per tiles)
+extern uint16 _si_landing_fee;                ///< cost for airports landing fee (per tons of cargo capacity)
+extern uint8 _si_provision;                   ///< value for depots provision (buy cost %)
+extern uint8 _si_road_stops_fee;              ///< cost for entering road stops (per tons of cargo capacity)
+extern uint8 _si_harbours_fee;                ///< cost for entering harbours (per tons of cargo capacity)
+
+/* shared infrastructure functions */
+bool SharedTracks(TileIndex tile, Owner owner);                               ///< check if tracks on tile are shared
+bool SharedRailwayStations(TileIndex tile, Owner owner);                      ///< check if railway station is shared
+bool SharedRailwayDepots(TileIndex tile, Owner owner);                        ///< check if railway depot is shared
+bool SharedRoadDepots(TileIndex tile, Owner owner);                           ///< check if road depot is shared
+bool SharedRoadStops(TileIndex tile, Owner owner);                            ///< check if road stops is shared
+bool SharedWaterDepots(TileIndex tile, Owner owner);                          ///< check if water depot is shared
+bool SharedHarbours(TileIndex tile, Owner owner);                             ///< check if harbour is shared
+bool SharedAirports(TileIndex tile, Owner owner);                             ///< check if airport is shared
+bool SharedDepotTransport(TileIndex tile, Owner owner, TransportType type);   ///< check if depot for this transport type is shared
+bool SharedDepotVehicleType(TileIndex tile, Owner owner, VehicleType type);   ///< check if depot for this vehicle type is shared
+bool SharedStation(TileIndex tile, Owner owner, VehicleType type);            ///< check if station is shared
+void SharedDepotProvision(CommandCost cost, Owner owner, uint32 flags);       ///< calculate depot provision
+void SharedStationFee(Owner station_owner, VehicleID vehicle);                ///< calculate station fee for this vehicle
+int32 SettingsEnableSharedRailwayStations(int32 p1);                          ///< activate railway tracks sharing when activating railway station sharing
+int32 SettingsEnableSharedRailwayTracks(int32 p1);                            ///< desactivate railway stations and depots sharing when removing tracks sharing
+void UpdateSharedOnRemove(VehicleID vehicle);                                 ///< clean infrastructure when removing vehicle
+void OnSharedClose(PlayerID old_player, uint closing_bit);                    ///< take care of vehicles on closing shared infrastructure
+void SharedCloseOnRoad (PlayerID p, VehicleID v);                             ///< remove road vehicles on closing shared infrastructure
+void SharedCloseOnRail (PlayerID p, VehicleID v);                             ///< remove rail vehicles on closing shared infrastructure
+void SharedCloseOnAir (PlayerID p, VehicleID v);                              ///< remove aircraft on closing shared airports 
+bool SharedCloseDepotTeleport (VehicleID v, uint16 depot);                    ///< teleport vehicle to depot, return false if failed
+bool SharedCloseHangarTeleport (VehicleID v, uint16 depot);                   ///< teleport vehicle to hangar, return false if failed
+uint16 SharedCloseGetFirstDepot (PlayerID p, VehicleID v, bool check_player); ///< get fist available depot to move vehicle on bankrupt company's shared infrastructure
+uint16 SharedCloseGetFirstHangar(PlayerID p, VehicleID v, bool check_player); ///< get fist available hangar to move aircraft on bankrupt company's shared airports
+
+CommandCost CmdSetSharedBoolValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2);  ///< set shared settings for player
+CommandCost CmdSetSharedIntValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2);   ///< set int shared settings for player
+
+#endif //SHAREDINFRASTRCUTURE_H
\ No newline at end of file
Index: src/signal.cpp
===================================================================
--- src/signal.cpp	(revision 13552)
+++ src/signal.cpp	(working copy)
@@ -18,6 +18,7 @@
 #include "track_func.h"
 #include "signal_func.h"
 #include "player_func.h"
+#include "sharedinfrastructure.h"
 
 
 /** these are the maximums used for updating signal blocks */
@@ -280,7 +281,7 @@
 
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY: {
-				if (GetTileOwner(tile) != owner) continue; // do not propagate signals on others' tiles (remove for tracksharing)
+				if ((GetTileOwner(tile) != owner) && !SharedTracks(GetTileOwner(tile), owner)) continue; // do not propagate signals on tiles of those with whom you are not sharing track
 
 				if (IsRailDepot(tile)) {
 					if (enterdir == INVALID_DIAGDIR) { // from 'inside' - train just entered or left the depot
@@ -353,7 +354,7 @@
 
 			case MP_STATION:
 				if (!IsRailwayStation(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && !SharedTracks(GetTileOwner(tile), owner)) continue;
 				if (DiagDirToAxis(enterdir) != GetRailStationAxis(tile)) continue; // different axis
 				if (IsStationTileBlocked(tile)) continue; // 'eye-candy' station tile
 
@@ -363,7 +364,7 @@
 
 			case MP_ROAD:
 				if (!IsLevelCrossing(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && (!SharedTracks(GetTileOwner(tile), owner))) continue;
 				if (DiagDirToAxis(enterdir) == GetCrossingRoadAxis(tile)) continue; // different axis
 
 				if (!(flags & SF_TRAIN) && VehicleFromPos(tile, NULL, &TrainOnTileEnum)) flags |= SF_TRAIN;
@@ -371,7 +372,7 @@
 				break;
 
 			case MP_TUNNELBRIDGE: {
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && (!SharedTracks(GetTileOwner(tile), owner))) continue;
 				if (GetTunnelBridgeTransportType(tile) != TRANSPORT_RAIL) continue;
 				DiagDirection dir = GetTunnelBridgeDirection(tile);
 
Index: src/vehicle.cpp
===================================================================
--- src/vehicle.cpp	(revision 13552)
+++ src/vehicle.cpp	(working copy)
@@ -1964,6 +1964,7 @@
 	SLE_CONDNULL(5,                                                         0, 57),
 	    SLE_VAR(Vehicle, engine_type,          SLE_UINT16),
 
+	    SLE_CONDARR(Vehicle, shared_tontiles,  SLE_UINT64, MAX_PLAYERS,     85, SL_MAX_VERSION),
 	    SLE_VAR(Vehicle, max_speed,            SLE_UINT16),
 	    SLE_VAR(Vehicle, cur_speed,            SLE_UINT16),
 	    SLE_VAR(Vehicle, subspeed,             SLE_UINT8),
@@ -2252,7 +2253,7 @@
 			cp->source_xy       = _cargo_source_xy;
 			cp->count           = _cargo_count;
 			cp->days_in_transit = _cargo_days;
-			cp->feeder_share    = _cargo_feeder_share;
+			cp->feeder_share[0] = _cargo_feeder_share;
 			cp->loaded_at_xy    = _cargo_loaded_at_xy;
 			v->cargo.Append(cp);
 		}
Index: src/vehicle_base.h
===================================================================
--- src/vehicle_base.h	(revision 13552)
+++ src/vehicle_base.h	(working copy)
@@ -193,6 +193,7 @@
 extern void AfterLoadVehicles(bool clear_te_id);
 struct LoadgameState;
 extern bool LoadOldVehicle(LoadgameState *ls, int num);
+// extern bool SharedCloseHangarTeleport (VehicleID vehicle, StationID station);
 
 struct Vehicle : PoolItem<Vehicle, VehicleID, &_Vehicle_pool>, BaseVehicle {
 private:
@@ -203,6 +204,7 @@
 	friend const SaveLoad *GetVehicleDescription(VehicleType vt); ///< So we can use private/protected variables in the saveload code
 	friend void AfterLoadVehicles(bool clear_te_id);              ///< So we can set the previous and first pointers while loading
 	friend bool LoadOldVehicle(LoadgameState *ls, int num);       ///< So we can set the proper next pointer while loading
+	friend bool SharedCloseHangarTeleport (VehicleID vehicle, StationID station); ///< So we can set the proper next pointer while teleporting an air vehicle
 
 	Vehicle *depot_list;     ///< NOSAVE: linked list to tell what vehicles entered a depot during the last tick. Used by autoreplace
 
@@ -264,6 +266,8 @@
 	int8 y_offs;             // y offset for vehicle sprite
 	EngineID engine_type;
 
+	OverflowSafeInt64 shared_tontiles[MAX_PLAYERS];  //Amount of tons*tiles traveled on shared tracks
+
 	TextEffectID fill_percent_te_id; // a text-effect id to a loading indicator object
 	UnitID unitnumber;       // unit number, for display purposes only
 
